<template>
  <div>
    <el-row>
      <!--查询-->
      <el-col :span="24">
        <Form
          inline
          onsubmit="return false"
          :label-width="70"
          v-show="searchOpen">
          <label class="label-sign"></label>
          <Form-item class="search-item" label="报表名称:">
            <el-input v-model="formObj.name" placeholder="请输入报表名称" @keyup.enter.native="_formSearch" clearable></el-input>
          </Form-item>
          <Form-item class="search-item" label="服务名称:">
            <el-input v-model="formObj.service" placeholder="请输入服务名称" @keyup.enter.native="_formSearch" clearable></el-input>
          </Form-item>
          <Form-item class="search-btn">
            <el-button type="primary" @click="_formSearch">搜索</el-button>
          </Form-item>
        </Form>
      </el-col>
      <!--按钮-->
      <el-col :span="24">
        <btn-list :msg="btn" :open="searchOpen" @on-result-change="_btnClick" showSearchBtn="true"/>
      </el-col>
      <!--table-->
      <el-col :span="24">
        <element-table
          :pageColumns="pageColumns"
          :tableHeight="tableHeight"
          @on-result-change="_tableResultChange"
          ref="pageTable"
          :getPage="getPage"
          :optColWidth="100"
          :iconMsg="iconMsg">
          <el-table-column
            show-overflow-tooltip
            sortable
            :prop="item.key"
            :label="item.title"
            :width="item.width"
            :min-width="200"
            :fixed="item.fixed?item.fixed:undefined"
            v-for="item in pageColumns"
            :key="item.key">
            <template slot-scope="scope">
              <div v-if="item.dateTime">
                {{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd HH:MM:ss'):''}}
              </div>
              <div v-else>{{scope.row[item.key]}}</div>
            </template>
          </el-table-column>
        </element-table>
      </el-col>
    </el-row>
    <!--添加-->
    <selServiceTypeModal ref="serviceModal"></selServiceTypeModal>
  </div>
</template>
<script>
import { printXml } from '../../../api'
import global from '../../../api/config'
import selServiceTypeModal from './selServiceTypeModal'
export default {
  components: { selServiceTypeModal },
  data() {
    return {
      searchOpen: true,
      formObj: {
        name: '',
        alias: ''
      },
      btn: [{ type: 'success', id: '', name: '添加' }],
      pageColumns: [
        { title: '报表名称', key: 'name' },
        { title: '服务名称', key: 'service', width: 120 },
        { title: '添加人', key: 'operator', width: 120 },
        { title: '添加日期', key: 'ctime', dateTime: true, width: 140 }
      ],
      getPage: {},
      iconMsg: [
        { type: 'pt-edit', id: '', name: '编辑' },
        { type: 'pt-trash', id: '', name: '删除' }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._formSearch()
  },
  methods: {
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await printXml.page(this.$serializeForm(this.formObj))
      if (result) {
        this.getPage = result
        this.$refs.pageTable._initTable()
      }
    },
    _btnClick(msg, data) {
      switch (msg) {
        case '添加':
          // 打开报表编辑器
          this.$refs.serviceModal._open()
          break
        case 'search':
          this.searchOpen = !this.searchOpen
          break
      }
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          this._page()
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData)
          break
      }
    },
    _iconClick(res, data) {
      switch (res) {
        case '编辑':
          window.open(
            global.baseURL +
              '/' +
              data.service +
              '/report/designer?_u=db' +
              data.name
          )
          break
        case '删除':
          this._deleteById(data.id)
          break
      }
    },
    _deleteById(id) {
      this.$Modal.confirm({
        title: '提示',
        content: '确定删除该记录？',
        onOk: () => {
          this._delOk(id)
        }
      })
    },
    _delOk: async function(id) {
      const result = await printXml.deleteById(id)
      if (result) {
        this.$message.success('删除成功')
        this._page()
      }
    }
  }
}
</script>
